
/**Copyright (c) 2009, Ioannis (John) Chtzikonstantinou, All rights reserved.
 ***http://prototy.blogspot.com
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 	- Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 	- Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 */

class lineSegment {

  Point2 p1,p2;

  float W=1.81;

  lineSegment(Point2 p1in, Point2 p2in) {
    p1=p1in;
    p2=p2in;
  }
  void draw() {
    float r=width/FLUID_WIDTH;
    float w=W*2;
    stroke(255);
    strokeWeight(w);
    line(p1.x*r,p1.y*r,p2.x*r,p2.y*r);
    noStroke();
    fill(255);
    ellipse(p1.x*r,p1.y*r,w,w);
    ellipse(p2.x*r,p2.y*r,w,w);
  }
}

public final class linePoint2 {
  int index;
  Point2 Pn;
  linePoint2(int indexin,Point2 pnormalin) {
    index=indexin;
    Pn=pnormalin;
  }
  void update() {
    Point2 U=new Point2(fluidSolver.u[index],fluidSolver.v[index]);
    Point2 Un=pTL(new Point2(0,0),Pn,U);// project U to normal
    Un.mult(-1.00);
    fluidSolver.u[index]+=Un.x;
    fluidSolver.v[index]+=Un.y;
  }
}

public static final class Point2 {
  float x,y;
  Point2(float xin, float yin) {
    x=xin;
    y=yin;
  }
  float distance(Point2 pin) {
    float dx=pin.x-x;
    float dy=pin.y-y;
    return sqrt(dx*dx+dy*dy);
  }
  Point2 plus(Point2 pin) {
    return new Point2(x+pin.x,y+pin.y);
  }
  Point2 minus(Point2 pin) {
    return new Point2(x-pin.x,y-pin.y);
  }
  Point2 mult(float i) {
    return new Point2(x*=i, y*=i);
  }
  Point2 cp() {
    return new Point2(x,y);
  }
  Point2 lperp() {
    return new Point2(-y,x);
  }
  Point2 rperp() {
    return new Point2(y,-x);
  }
  Point2 n() {
    final float m=sqrt(x*x+y*y);
    return new Point2(x/m,y/m);
  }
  void inherit(Point2 pin) {
    x=pin.x;
    y=pin.y;
  }
  float dot(Point2 pin) {
    return x*pin.x+y*pin.y;
  }
}


