
/**Copyright (c) 2009, Ioannis (John) Chtzikonstantinou, All rights reserved.
 ***http://prototy.blogspot.com
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 	- Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 	- Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 */

// Visualize Velocity Field

void drawVelocityField() {
  final float f=width/FLUID_WIDTH;
  final float ff=0.80*f;
  noFill();
  strokeWeight(1);
  for (int j=0,l=(int)(FLUID_WIDTH*height/width);j<l;j++) {
    for (int i=0,k=(int)FLUID_WIDTH-(int)(125/f);i<k;i++) {
      int index=fluidSolver.getIndexForCellPosition(i,j);
      float v2=fluidSolver.u[index]*fluidSolver.u[index]+fluidSolver.v[index]*fluidSolver.v[index];
      final float f2=2.9+0.03*v2;
      stroke(255,22);
      line(i*f+random(f2)-f2*0.50,j*f+random(f2)-f2*0.50,i*f+fluidSolver.u[index]*ff+random(f2)-f2*0.50,
      j*f+fluidSolver.v[index]*ff+random(f2)-f2*0.50);
    }
  }
}

void rDraw() {
background(0);
  drawVelocityField();
  if (drawObj) {
    for (int i=0,j=lineSegments.size();i<j;i++) {
      lineSegment l=(lineSegment)lineSegments.get(i);
      l.draw();
    }
    for (int i=0,j=thrustSegments.size();i<j;i++) {
      thrustSegment t=(thrustSegment)thrustSegments.get(i);
      t.draw();
    }
  }
  noFill();
  stroke(220);
  strokeWeight(1);
  line(mouseX,0,mouseX,width-50);
  line(0,mouseY,width,mouseY);
  if (drawMode==1) {
    noFill();
    stroke(225);
    strokeWeight(3);
    line(tx,ty,mouseX,mouseY);
  }
  else if (drawMode==2) {
    stroke(100);
    strokeWeight(10);
    float r=width/FLUID_WIDTH;
    line(p1.x*r,p1.y*r,p2.x*r,p2.y*r);
  }
  else if (drawMode==0 && mousePressed) {
    noFill();
    stroke(100);
    strokeWeight(3);
    line(tx,ty,mouseX,mouseY);
  }
  noStroke();
  fill(0);
  rect(width-120,0,120,height);
  if (tunnelFlow) {
    image(imgFlow, width-120, height-30); 
  }
  if (drawObj) {
    image(imgVis, width-100, height-30); 
  }
  if (!visMode) {
    image(img2d, width-80,height-30);
  }
}
