
/**Copyright (c) 2009, Ioannis (John) Chtzikonstantinou, ?All rights reserved.
 ***http://prototy.blogspot.com
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 	- Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 	- Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 */

import msafluid.*;
import processing.opengl.*;
import javax.media.opengl.*;
import java.util.Vector;

static final float FLUID_WIDTH = 180;
static int noCells;
static float invWidth, invHeight;    // inverse of screen dimensions

MSAFluidSolver2D fluidSolver;

Vector lineSegments = new Vector();
Vector linePoints=new Vector();
Vector thrustSegments = new Vector();
Vector thrustPoints=new Vector();

float[] Velocities;

// Real Values
int tx=0;
int ty=0;
//Simulation Values
float mX=0;
float mY=0;
float tX=0;
float tY=0;

int drawMode=0;
boolean drawObj=true;
boolean tunnelFlow=false;
boolean visMode=false;

static PImage imgVis;
static PImage imgFlow;
static PImage img2d;

void setup() {
  size(1024, 450, OPENGL);    // use OPENGL rendering for bilinear filtering on texture
  frameRate(24);
  hint( ENABLE_OPENGL_4X_SMOOTH );    // Turn on 4X antialiasing
  this.frame.setTitle("TN6");
  background(0);
  // create fluid and set options
  invWidth=1.0f/width;
  invHeight=1.0f/height;
  fluidSolver = new MSAFluidSolver2D((int)(FLUID_WIDTH), (int)(FLUID_WIDTH * height/width));
  fluidSolver.setSolverIterations(10).setDeltaT(.00006).setVisc(0.35);

  imgVis = loadImage("vis.jpg");
  imgFlow = loadImage("flow.jpg");
  img2d = loadImage("2d.jpg");
  
  Velocities = new float[fluidSolver.u.length];

  setupCam();
  noCursor();
}

void draw() {
  mX=(mouseX*FLUID_WIDTH/width);
  mY=(mouseY*FLUID_WIDTH/width);

  updateSolver();
  if (!visMode) {
    rDraw();
  } 
  else {
    draw3DField();
  }
}



