
/**Copyright (c) 2009, Ioannis (John) Chtzikonstantinou, ?All rights reserved.
 ***http://prototy.blogspot.com
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 	- Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 	- Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 */
import processing.dxf.*;

void export(String file) {
   beginRaw(DXF, file); // Start recording to the file
   final float f=width/FLUID_WIDTH;
  final float ff=0.20*f;
  final float rt=5;
 
  for (int i=0;i<Velocities.length;i++) {
    Velocities[i]=dist(0,0,fluidSolver.u[i],fluidSolver.v[i]);
  }
  for (int j=0,l=(int)(FLUID_WIDTH*height/width)-1;j<l;j++) {
    for (int i=5,k=(int)FLUID_WIDTH-(int)(125/f)-1;i<k;i++) {
      int index0=fluidSolver.getIndexForCellPosition(i,j);
      int index1=fluidSolver.getIndexForCellPosition(i+1,j);
      int index2=fluidSolver.getIndexForCellPosition(i,j+1);
      int index3=fluidSolver.getIndexForCellPosition(i+1,j+1);
      final float f0=rt*Velocities[index0];
      final float f1=rt*Velocities[index1];
      final float f2=rt*Velocities[index2];
      final float f3=rt*Velocities[index3];
      beginShape(TRIANGLE_FAN);
      vertex(f*i,f*j,f0);
      vertex(f*(i+1),f*j,f1);
      vertex(f*(i+1),f*(j+1),f3);
      vertex(f*i,f*(j+1),f2);
      endShape();
      beginShape(TRIANGLE_FAN);
      vertex(f*i,f*j,-f0);
      vertex(f*(i+1),f*j,-f1);
      vertex(f*(i+1),f*(j+1),-f3);
      vertex(f*i,f*(j+1),-f2);
      endShape();
    }
  }
    endRaw();
}

